

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.utils.errors &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../index.html"/>
        <link rel="up" title="Module code" href="../../index.html"/> 

  
  <script src="../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.utils.errors</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.utils.errors</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">math</span>

<div class="viewcode-block" id="float_equal"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.float_equal">[docs]</a><span class="k">def</span> <span class="nf">float_equal</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">y</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="mf">0.001</span><span class="p">):</span>
  <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="nb">float</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="o">-</span> <span class="nb">float</span><span class="p">(</span><span class="n">y</span><span class="p">))</span> <span class="o">&lt;=</span> <span class="n">limit</span></div>

<div class="viewcode-block" id="to_array"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.to_array">[docs]</a><span class="k">def</span> <span class="nf">to_array</span><span class="p">(</span><span class="n">l</span><span class="p">):</span>
  <span class="k">if</span> <span class="p">(</span><span class="nb">isinstance</span><span class="p">(</span><span class="n">l</span><span class="p">,</span> <span class="nb">list</span><span class="p">)):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">l</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float64</span><span class="p">)</span>
  <span class="k">elif</span> <span class="p">(</span><span class="n">is_numeric</span><span class="p">(</span><span class="n">l</span><span class="p">)):</span>
    <span class="k">return</span> <span class="n">l</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Can not convert type: </span><span class="si">%s</span><span class="s2"> to array&quot;</span> <span class="o">%</span> <span class="nb">type</span><span class="p">(</span><span class="n">l</span><span class="p">))</span></div>

<div class="viewcode-block" id="is_numeric"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.is_numeric">[docs]</a><span class="k">def</span> <span class="nf">is_numeric</span><span class="p">(</span><span class="n">obj</span><span class="p">):</span>
  <span class="n">attrs</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;__add__&#39;</span><span class="p">,</span> <span class="s1">&#39;__sub__&#39;</span><span class="p">,</span> <span class="s1">&#39;__mul__&#39;</span><span class="p">,</span> <span class="s1">&#39;__div__&#39;</span><span class="p">,</span> <span class="s1">&#39;__pow__&#39;</span><span class="p">]</span>
  <span class="k">return</span> <span class="nb">all</span><span class="p">(</span><span class="nb">hasattr</span><span class="p">(</span><span class="n">obj</span><span class="p">,</span> <span class="n">attr</span><span class="p">)</span> <span class="k">for</span> <span class="n">attr</span> <span class="ow">in</span> <span class="n">attrs</span><span class="p">)</span></div>

<div class="viewcode-block" id="absolute_error"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.absolute_error">[docs]</a><span class="k">def</span> <span class="nf">absolute_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="n">approximate</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">approximate</span><span class="p">)</span>
  <span class="n">exact</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">exact</span><span class="p">)</span>

  <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">exact</span> <span class="o">-</span> <span class="n">approximate</span><span class="p">)</span></div>

<span class="c1"># Relative error</span>
<span class="c1"># Absolute error / exact values</span>
<div class="viewcode-block" id="relative_error"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.relative_error">[docs]</a><span class="k">def</span> <span class="nf">relative_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="n">approximate</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">approximate</span><span class="p">)</span>
  <span class="n">exact</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">exact</span><span class="p">)</span>

  <span class="n">ret</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="n">approximate</span><span class="o">/</span><span class="n">exact</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>

  <span class="c1"># Check for elements where approximate == exact</span>
  <span class="c1"># and replace inf with 0.0</span>
  <span class="c1"># TODO: Tidy up</span>
  <span class="n">indices_to_replace</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">approximate</span><span class="o">.</span><span class="n">tolist</span><span class="p">())):</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">float_equal</span><span class="p">(</span><span class="n">approximate</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">exact</span><span class="p">[</span><span class="n">i</span><span class="p">])):</span>
      <span class="n">indices_to_replace</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

  <span class="n">nret</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">el</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">ret</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">indices_to_replace</span><span class="p">:</span>
      <span class="n">nret</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mf">0.0</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">nret</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">el</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">nret</span><span class="p">)</span></div>

<div class="viewcode-block" id="percent_difference"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.percent_difference">[docs]</a><span class="k">def</span> <span class="nf">percent_difference</span><span class="p">(</span><span class="n">val1</span><span class="p">,</span> <span class="n">val2</span><span class="p">):</span>
  <span class="n">val1</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">val1</span><span class="p">)</span>
  <span class="n">val2</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">val2</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">((</span><span class="n">val1</span><span class="o">-</span><span class="n">val2</span><span class="p">)</span><span class="o">/</span><span class="p">((</span><span class="n">val1</span><span class="o">+</span><span class="n">val2</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">))</span><span class="o">*</span><span class="mi">100</span></div>

<span class="c1"># Percent error</span>
<span class="c1"># (relative error * 100)</span>
<div class="viewcode-block" id="percent_error"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.percent_error">[docs]</a><span class="k">def</span> <span class="nf">percent_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="k">return</span> <span class="n">relative_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span><span class="o">*</span><span class="mi">100</span></div>

<span class="c1"># Mean absolute error</span>
<div class="viewcode-block" id="mae"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.mae">[docs]</a><span class="k">def</span> <span class="nf">mae</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">median</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
  <span class="n">abs_error</span> <span class="o">=</span> <span class="n">absolute_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">median</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="n">abs_error</span><span class="p">)</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="k">return</span> <span class="n">abs_error</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span></div>

<span class="c1"># Mean absolute percentage error</span>
<span class="c1"># (mean of percent errors)</span>
<div class="viewcode-block" id="mape"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.mape">[docs]</a><span class="k">def</span> <span class="nf">mape</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">median</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
  <span class="n">per_error</span> <span class="o">=</span> <span class="n">percent_error</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span>

  <span class="n">finites</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">el</span> <span class="ow">in</span> <span class="n">per_error</span><span class="p">:</span>
    <span class="k">try</span><span class="p">:</span>
      <span class="k">if</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">isfinite</span><span class="p">(</span><span class="n">el</span><span class="p">)):</span>
        <span class="n">finites</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">el</span><span class="p">)</span>
    <span class="k">except</span><span class="p">:</span>
      <span class="k">continue</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">median</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="n">finites</span><span class="p">)</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">finites</span><span class="p">)</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span></div>

<span class="c1"># Symmetric absolute percentage error</span>
<div class="viewcode-block" id="sapes"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.sapes">[docs]</a><span class="k">def</span> <span class="nf">sapes</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="n">approximate</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">approximate</span><span class="p">)</span>
  <span class="n">exact</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">exact</span><span class="p">)</span>

  <span class="n">indices_to_replace</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">approximate</span><span class="o">.</span><span class="n">tolist</span><span class="p">())):</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">float_equal</span><span class="p">(</span><span class="n">approximate</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">exact</span><span class="p">[</span><span class="n">i</span><span class="p">])):</span>
      <span class="n">indices_to_replace</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>

  <span class="n">ret</span> <span class="o">=</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">exact</span><span class="o">-</span><span class="n">approximate</span><span class="p">)</span><span class="o">/</span><span class="p">(</span><span class="n">exact</span> <span class="o">+</span> <span class="n">approximate</span><span class="p">)</span> <span class="o">*</span> <span class="mi">100</span><span class="p">)</span><span class="o">.</span><span class="n">tolist</span><span class="p">()</span>

  <span class="n">nret</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">el</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">ret</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">i</span> <span class="ow">in</span> <span class="n">indices_to_replace</span><span class="p">:</span>
      <span class="n">nret</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mf">0.0</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">nret</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">el</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">nret</span><span class="p">)</span></div>

<span class="c1"># Symmetric mean absolute percentage error</span>
<div class="viewcode-block" id="smape"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.smape">[docs]</a><span class="k">def</span> <span class="nf">smape</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">median</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
  <span class="n">sapes_</span> <span class="o">=</span> <span class="n">sapes</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">median</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="n">sapes_</span><span class="p">)</span>
  <span class="k">else</span><span class="p">:</span>
    <span class="k">return</span> <span class="n">sapes_</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span></div>

<span class="c1"># Mean squared error</span>
<div class="viewcode-block" id="mse"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.mse">[docs]</a><span class="k">def</span> <span class="nf">mse</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="n">approximate</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">approximate</span><span class="p">)</span>
  <span class="n">exact</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">exact</span><span class="p">)</span>

  <span class="k">return</span> <span class="p">((</span><span class="n">approximate</span><span class="o">-</span><span class="n">exact</span><span class="p">)</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span><span class="o">.</span><span class="n">mean</span><span class="p">()</span></div>

<span class="c1"># Root mean squared error</span>
<div class="viewcode-block" id="rmse"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.rmse">[docs]</a><span class="k">def</span> <span class="nf">rmse</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="k">return</span> <span class="n">math</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">mse</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">))</span></div>

<span class="c1"># Mean absolute scaled error</span>
<span class="c1"># Train is the expected outputs (targets) in the training set</span>
<div class="viewcode-block" id="mase"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.mase">[docs]</a><span class="k">def</span> <span class="nf">mase</span><span class="p">(</span><span class="n">train</span><span class="p">,</span> <span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">):</span>
  <span class="n">train</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">train</span><span class="p">)</span>
  <span class="n">approximate</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">approximate</span><span class="p">)</span>
  <span class="n">exact</span> <span class="o">=</span> <span class="n">to_array</span><span class="p">(</span><span class="n">exact</span><span class="p">)</span>

  <span class="n">n</span> <span class="o">=</span> <span class="n">train</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="c1"># Length</span>
  <span class="n">scaling</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="n">train</span><span class="p">))</span><span class="o">.</span><span class="n">sum</span><span class="p">()</span> <span class="o">/</span> <span class="p">(</span><span class="n">n</span> <span class="o">-</span> <span class="mi">1</span><span class="p">)</span>

  <span class="k">return</span> <span class="n">mae</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span><span class="o">/</span><span class="n">scaling</span></div>

<span class="c1"># Returns a vector of hits (1.0) and misses (0.0)</span>
<span class="c1"># based on the percent error</span>
<span class="c1"># If the sape &lt;= threshold % -&gt; hit</span>
<span class="c1"># If the sape &gt; threshold % -&gt; miss</span>
<span class="c1"># Threshold defaults to SMdAPE</span>
<div class="viewcode-block" id="hits"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.hits">[docs]</a><span class="k">def</span> <span class="nf">hits</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">th</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
  <span class="n">sapes_</span> <span class="o">=</span> <span class="n">sapes</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">)</span>
  <span class="n">threshold</span> <span class="o">=</span> <span class="n">th</span> <span class="k">if</span> <span class="n">th</span> <span class="o">!=</span> <span class="bp">None</span> <span class="k">else</span> <span class="nb">int</span><span class="p">(</span><span class="n">smape</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">median</span><span class="o">=</span><span class="bp">True</span><span class="p">))</span>

  <span class="n">hm</span> <span class="o">=</span> <span class="p">[]</span>
  <span class="k">for</span> <span class="n">el</span> <span class="ow">in</span> <span class="n">sapes_</span><span class="o">.</span><span class="n">tolist</span><span class="p">():</span>
    <span class="k">if</span> <span class="n">el</span> <span class="o">&lt;=</span> <span class="n">threshold</span><span class="p">:</span>
      <span class="n">hm</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">hm</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>

  <span class="k">return</span> <span class="n">hm</span></div>

<div class="viewcode-block" id="percent_hits"><a class="viewcode-back" href="../../../d2o.utils.html#d2o.utils.errors.percent_hits">[docs]</a><span class="k">def</span> <span class="nf">percent_hits</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">th</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
  <span class="n">hm</span> <span class="o">=</span> <span class="n">hits</span><span class="p">(</span><span class="n">approximate</span><span class="p">,</span> <span class="n">exact</span><span class="p">,</span> <span class="n">th</span><span class="p">)</span>
  <span class="n">num_hits</span> <span class="o">=</span> <span class="n">hm</span><span class="o">.</span><span class="n">count</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>

  <span class="k">return</span> <span class="p">(</span><span class="nb">float</span><span class="p">(</span><span class="n">num_hits</span><span class="p">)</span><span class="o">/</span><span class="nb">len</span><span class="p">(</span><span class="n">exact</span><span class="p">))</span> <span class="o">*</span> <span class="mi">100</span></div>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>